<script lang="ts">
  import registrationBg from '$lib/assets/images/home/collaborative.png';
  import Spinner from "$lib/components/ui-elements/Spinner.svelte";
  import { TeamByPkStore } from "$houdini";
  import type { Team, Writeable } from '$lib/graphql/types';
  import ExistingTeamCard from '$lib/components/ui-elements/ExistingTeamCard.svelte';

  export let teamId: string;
  export let hideControls = false;
  export let background = registrationBg;

  const defaultError = "Failed to fetch team data";
  let error = defaultError;

  $: teamStore = new TeamByPkStore();
  $: teamStore.subscribe((result) => {
    if (result.errors?.length) console.error('failed fetch', result.errors);
  });
  let team: Team | null = null;
  $: fetch(teamId);

  async function fetch(team_id: string) {
    try {
      await teamStore.fetch({ variables: { team_id } });
      // NOTE: must do this over `$: team = $teamStore.data?.teams_by_pk;`, otherwise nulls will appear 👻
      // typing override so that we can pass to TeamTable
      if ($teamStore.data && $teamStore.data.teams_by_pk) {
        let tmp = $teamStore.data.teams_by_pk as Writeable<Team>
        // hack to keep liaison from displaying twice in existing team card
        tmp.liaison = null;
        team = tmp as Team;
      }
    } catch (e) {
      error = JSON.stringify(e, null, 2)
      team = null;
    }
  }

</script>

{#if $teamStore.fetching}
  <Spinner />
{:else if !team}
  <p>{error}</p>
{:else}
  <ExistingTeamCard
    on:refetch={() => fetch(teamId)}
    {background}
    {team}
    {hideControls}
  />
{/if}
